"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class DiagnosticDetail(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "diagnosisCode",
        "diagnosisCodingSystem",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_9 import participant as participant_1_3_0

        return {
            "org.gel.models.participant.avro.DiagnosticDetail": participant_1_3_0.DiagnosticDetail,
        }

    __slots__ = [
        "diagnosisCode",
        "diagnosisCodingSystem",
        "ageAtOnsetInYears",
        "diagnosisCertainty",
        "diagnosisCodingSystemVersion",
        "diagnosisDescription",
    ]

    def __init__(
        self,
        diagnosisCode,
        diagnosisCodingSystem,
        ageAtOnsetInYears=None,
        diagnosisCertainty=None,
        diagnosisCodingSystemVersion=None,
        diagnosisDescription=None,
        validate=None,
        **kwargs
    ):
        """Initialise the participant_1_3_0.DiagnosticDetail model.

        :param diagnosisCode:
            Diagnosis Code
        :type diagnosisCode: str
        :param diagnosisCodingSystem:
            Diagnosis coding system
        :type diagnosisCodingSystem: str
        :param ageAtOnsetInYears:
            Age at diagnosis
        :type ageAtOnsetInYears: None | float
        :param diagnosisCertainty:
            Diagnosis Certainty
        :type diagnosisCertainty: None | str
        :param diagnosisCodingSystemVersion:
            Diagnosis Coding System Version
        :type diagnosisCodingSystemVersion: None | str
        :param diagnosisDescription:
            Diagnosis description
        :type diagnosisDescription: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.3.0"
